<?php
/* UTF-8! ÜÕÄÖõüäö
######################################################################
Rif Custom Thumbnail Gallery plugin fo gpEasy
Author: Rif T. Laasi
Date: 2016-02-20
Version 1.0 beta
######################################################################
*/
defined('is_running') or die('Not an entry point...');

gpPlugin::incl('ThumbnailGalleryFunctions.php','require_once');

class CustomThumbnailGallery extends ThumbnailGalleryFunctions{


	/**
	 * Generate a pseudo-random key for the content key to prevent duplicates
	 *
	 */
	 
	static function ContentKey(){
		global $addonFolderName;

		static $key = false;
		if( $key !== false ){
			return $key;
		}

		$key = 'CustomThumbnailGallery';
		return $key;
	}

	/**
	 * @static
	 *
	 */
	static function SectionTypes($section_types, $generated_key = false ){
		global $langmessage, $addon_current_id;
		
		$label = "Custom Thumbnail Gallery";
		if(isset($langmessage[$addon_current_id]["--ADMIN_LINKS--"]['SectionType:'.self::ContentKey()]))
			$label = $langmessage[$addon_current_id]["--ADMIN_LINKS--"]['SectionType:'.self::ContentKey()];

		$section_types[self::ContentKey()] = array('label' => $label, 'color' => '#ff4000');
		return $section_types; 
	}

	/**
	 * @static
	 */
	static function SectionToContent($section_data){
		global $dataDir, $addonPathData;

		if( $section_data['type'] != self::ContentKey() ){
			return $section_data;
		}
	
	
		CustomThumbnailGallery::AddComponents();
		//if (self::detect_rifminicart('', true))
		//	$minicartinstalled=true;

		if (!isset($section_data['templatekey'])){//self::DefaultContent($default_content,$type)	
			return $section_data;
		}
		
	// IF GALLERY TEMPLATE DATAS IS MODIFIED OVERWRITE SECTION CONTENT FOR NEW VIEW (after gallery newly saved u not need owerwrite)

		$galdata = self::GetData();
		
		if(!array_key_exists($section_data['templatekey'], $galdata['ThumbGalData']))
			$section_data['templatekey'] = "0";
		
		$thumbdir = self::GetThumbDirname($section_data['templatekey'], $section_data['ThumbDir'], $galdata);
		
		//if image is not exist
		foreach($section_data['images'] as $i => $image ){			
			if (!file_exists($_SERVER['DOCUMENT_ROOT'].rawurldecode($image))){
				$noimage = true;
				break;
			}
		}
		// if template data is modified or not image exist
		if($section_data['Time'] !== $galdata['ThumbGalData'][$section_data['templatekey']]['time'] or isset($noimage)){
			$section_data['content'] = self::GenerateContent($section_data, $galdata, $thumbdir);
		}

		//if thumb sizes is changed outside ... thumbnails is needed overwrite once (greating temp file for not overwrite agen)
		$newdimens = $thumbdir['width'].'X'.$thumbdir['height'].'X'.$thumbdir['modus'];
		$tempfile = $addonPathData."/temp/".$section_data['modified']."_".$newdimens.".php";
		if($section_data['ThumbDimension'] != $newdimens && !file_exists($tempfile)){
			$section_data['content'] = self::GenerateContent($section_data, $galdata, $thumbdir, $overwrite_thumbs=true);
			if (!is_dir($addonPathData."/temp/"))
				mkdir($addonPathData."/temp/");
			touch($tempfile);
			//file_put_contents($tempfile, 'lorem ipsum');
		}
		
	//
				
		self::additionalJsCss($section_data['templatekey'], true, "default_set", "js");
		$jqcontainerselector = '$("#'.$section_data['GALId'].'")';
		
		$Qjs = '
			if($ThumbCalShapeshiftDATAS['.$section_data['templatekey'].'] === undefined)
			$ThumbCalShapeshiftDATAS['.$section_data['templatekey'].']=$ThumbCalShapeshiftDATA;
		'.$jqcontainerselector.'.imagesLoaded(function(){'.$jqcontainerselector.'.shapeshift($ThumbCalShapeshiftDATAS['.$section_data['templatekey'].']);});
		';
		
		global $page;
		$page->jQueryCode .= $Qjs;
		
		$section_data['content'] = $section_data['content'];
		
		return $section_data;
	}


	/**
	 * @static
	 */
	static function DefaultContent($default_content,$type){
		global $addonPathData, $addonPathCode;

		if( $type != self::ContentKey() ){
			return $default_content;
		}

	
		if (!file_exists($addonPathData.'/'.self::DataIndexFile))
			self::CopyDataFolder($addonPathCode."/defaults", $addonPathData);
		
		$templateid = "0";		
		$containerid = "GAL-".time();		
		$jqcontainerselector = '$("#'.$containerid.'")';

		ob_start();
		echo '<div id="rif_CustomThumbGallery">';//margin-left:50%;margin-right:auto;
		echo '<ul class="gp_gallery" id="'.$containerid.'" data-templateid="'.$templateid.'"><li class="gp_to_remove">'
		.'<a class="gallery_gallery" data-cmd="gallery" href="'.common::GetDir('/include/imgs/default_image.jpg').'" data-arg="gallery_gallery">'
		.'<img alt="" src="'.common::GetDir('/include/imgs/default_thumb.jpg').'" />'
		.'</a>'
		.'<div class="caption">'.CustomThumbnailGallery::LangMessages("Default content caption").'</div>'
		.'</li></ul>';
		echo '</div>'; 

		return ob_get_clean();
	}

	static function NewSections($links){
		global $addonRelativeCode;	
		//foreach ($links as $key => $link) {
		//	$match = is_array($link[0]) ? implode('-',$link[0]) : $link[0] ;
		//	if ($match == 'GoogleMaps_section') { $links[$key][1] = $addonRelativeCode . '/img/gm.png'; }
		//}

		return $links;		
	}

	static function GenerateContent($section_data, $galdata, $thumbdir, $overwrite_thumbs=false){
	
		if($overwrite_thumbs == false)
			unset($overwrite_thumbs);			
	
		$section_data += array('images'=>array());
		
		$templateid = $section_data['templatekey'];		
	
		$containerid = $section_data['GALId'];
		$jqcontainerselector = '$("#'.$containerid.'")';
		$container_classes = $galdata['ThumbGalData'][$templateid]['classes']['container'];
		$li_template = $galdata['ThumbGalData'][$templateid]['li_template'];

		$thumbdirname = $thumbdir["thumbdir"];

		ob_start();
		echo self::additionalJsCss($section_data['templatekey'], false, "default_set");
		echo '<div id="rif_CustomThumbGallery">';
		echo '<ul class="'.$container_classes.'" id="'.$containerid.'" data-templateid="'.$templateid.'" data-thumbdir="'.$thumbdirname.'">';

		$otherattr = ' data-arg="gallery_gallery" data-cmd="gallery" ';
		$classes = ' gallery_gallery ';
		
		$imgdir = common::GetDir();
		foreach($section_data['images'] as $i => $image ){
		//if prefix is cahnged (ex: all cms copied onother server dir)	
			$url = explode("/data/", $image); 
			$image = $imgdir.'data/'.$url[1];
		//	

			$thumb_path = self::ThumbnailPath($image, $thumbdirname);
			
			if (!file_exists($_SERVER['DOCUMENT_ROOT'].rawurldecode($image)) ){
				if(file_exists($_SERVER['DOCUMENT_ROOT'].$thumb_path))
					unlink ($_SERVER['DOCUMENT_ROOT'].$thumb_path);
				continue;
			}
		
			if (!file_exists($_SERVER['DOCUMENT_ROOT'].$thumb_path) or isset($overwrite_thumbs)	)	
				self::CreateThumbnail(rawurldecode($image), $thumbdir);

			$addOtherHTML = $section_data['addOtherHTMLs'][$i];
			$caption = $section_data['captions'][$i];
			gpFiles::cleanText($caption);
			$title_caption = htmlspecialchars($caption);
			$a_href = $image;

			echo '<li id='.self::base64url_encode($image).'>';
			echo self::ReplaceInLiTemplate($li_template, array('{$title_caption}'=>$title_caption,'{$caption}'=>$caption,'{$a_href}'=>$a_href, '{$thumb_path}'=>$thumb_path, '{$classes}'=>$classes, '{$otherattr}'=>$otherattr, '{$addOtherHTML}'=>$addOtherHTML));
			echo '</li>';
		}
		echo '</ul>';
		echo '</div>';

		//if(isset($_POST['galpreview']))
			//echo '<script type="text/javascript">
			//	if($ThumbCalShapeshiftDATAS['.$templateid.'] === undefined)
			//	$ThumbCalShapeshiftDATAS['.$templateid.']=$ThumbCalShapeshiftDATA;
			//'.$jqcontainerselector.'.imagesLoaded(function(){'.$jqcontainerselector.'.shapeshift($ThumbCalShapeshiftDATAS['.$templateid.']);});
			//</script>';
		
		return ob_get_clean();		
		
	}
	
	
	/**
	 * @static
	 */
	static function SaveSection($return,$section,$type){
		global $page, $addonPathData;
		
		if( $type != self::ContentKey() ){
			return $return;
		}

		$galdata = self::GetData(); //$galdata['ThumbGalData']['ThumbDir'] $galdata['ThumbDirAndDimens']   ['width']['width']		
		if(!isset($_REQUEST['templatekey']) or !array_key_exists($_REQUEST['templatekey'],$galdata['ThumbGalData']))
			$templatekey = "0";
		else
			$templatekey = $_REQUEST['templatekey'];
		
		$thumbdir = self::GetThumbDirname($templatekey, $_REQUEST['thumbdirname'], $galdata);//$thumbdir["thumbdir"] $thumbdir['height'] $thumbdir['width'] $out["nodif"]
		
		$page->file_sections[$section]['templatekey'] = $templatekey;
		
		$page->file_sections[$section]['GALId'] = "GAL-".time();
		if (isset($page->file_sections[$section]['modified']))
			$page->file_sections[$section]['GALId'] = "GAL-".$page->file_sections[$section]['modified'];		
		$page->file_sections[$section]['ThumbDir'] = $thumbdir["thumbdir"];
		$page->file_sections[$section]['ThumbDimension'] = $thumbdir['width'].'X'.$thumbdir['height'].'X'.$thumbdir['modus'];
		$page->file_sections[$section]['Time'] = $galdata['ThumbGalData'][$templatekey]['time'];
		$page->file_sections[$section]['images'] = $_REQUEST['images'];
		$page->file_sections[$section]['captions'] = $_REQUEST['captions'];
		$page->file_sections[$section]['addOtherHTMLs'] = $_REQUEST['addOtherHTMLs']; //now for rif minicart addon if installed

		$page->file_sections[$section]['content'] = self::GenerateContent($page->file_sections[$section], $galdata, $thumbdir);

		//includeFile('tool/SectionContent.php');
		$page->ajaxReplace = array();		
		//$content = section_content::RenderSection( $page->file_sections[$section], $section, "", "" );
		$page->ajaxReplace[] = array('gp_plugin_customthumbgal_content','', $page->file_sections[$section]['content']);

		if(isset($_POST['galpreview']))
			return false;

		//delete tempfiles ... see function self::SectionToContent($section_data) ... for thumbnails if thumb size modified outside section (thumbdir params is changed in admin page)
		if (isset($page->file_sections[$section]['modified'])){
			$files = glob($addonPathData."/temp/".$page->file_sections[$section]['modified']."_*.php");
			if(is_array($files) && count($files)>0){
				foreach ($files as $filename)
					unlink($filename);
			}
		}
		
		return true;
	}

	
	
	static function additionalJsCss($selecteddata_key, $tohead = false, $chemekey = "default_set", $CssOrJs = "css"){
		global $addonPathData, $addonFolderName, $dirPrefix, $page;
	
		if ($CssOrJs == "css"){
			if (file_exists($addonPathData.'/'.$selecteddata_key.'/'.$chemekey.'.less')){
					
				if (!file_exists($addonPathData.'/'.$selecteddata_key.'/'.$chemekey.'.css')){
					$less_files[] = $addonPathData.'/'.$selecteddata_key.'/'.$chemekey.'.less';
					$compiled = gpOutput::ParseLess( $less_files );
					if( !$compiled )
						message($langmessage['OOPS'].' (Invalid LESS)');
					else
						file_put_contents($addonPathData.'/'.$selecteddata_key.'/'.$chemekey.'.css', $compiled);					
				}

				if (!$tohead)
					return '<link type="text/css" href="'.$dirPrefix.'/data/_addondata/'.$addonFolderName.'/'.$selecteddata_key.'/'.$chemekey.'.css" rel="stylesheet"/>';
				else
					$page->css_user[] = $dirPrefix.'/data/_addondata/'.$addonFolderName.'/'.$selecteddata_key.'/'.$chemekey.'.css';
			}
		}
		
		if ($CssOrJs == "js"){
			
			if (file_exists($addonPathData.'/'.$selecteddata_key.'/'.$chemekey.'.js')){		
				if (!$tohead)
					return '<script type="text/javascript" src="'.$dirPrefix.'/data/_addondata/'.$addonFolderName.'/'.$selecteddata_key.'/'.$chemekey.'.js"></script>';
				else
					$page->head_js[] = 	$dirPrefix.'/data/_addondata/'.$addonFolderName.'/'.$selecteddata_key.'/'.$chemekey.'.js';					
			}
		}
	}


	static function ReplaceInLiTemplate($li_template, $replacewith){
		$replace = array('{$title_caption}', '{$caption}', '{$a_href}', '{$thumb_path}', '{$classes}', '{$otherattr}', '{$addOtherHTML}');
		foreach($replace as $val){
			if(!isset($replacewith[$val]))
				$replace_with[] = "";
			else
				$replace_with[] = $replacewith[$val];
		}
		$out = str_replace($replace, $replace_with, $li_template);
		return $out;
	}
	

	/**
	 * Make sure the .js and .css is available to admins
	 *
	 * @static
	 *
	 */
	static function GenerateContent_Admin(){
		global $addonFolderName, $page, $addonRelativeCode, $dirPrefix;
		$page->head_script .= "\nvar CustomThumbnailGallery_BASE = '".$addonRelativeCode."';";
		$page->head_script .= "\nvar CustomThumbnailGallery_DATA = '".$dirPrefix."/data/_addondata/".$addonFolderName."';";
		if( version_compare(gpversion,'5.0','>=') )
			$page->head_script .= "\nvar CustomThumbnailGallery_gpver = '5';";

		CustomThumbnailGallery::AddComponents(); 
		
	}


	static function AddComponents(){
		global $addonFolderName, $page, $addonRelativeCode, $config, $dataDir;
		static $done = false;

		if( $done ) return;

		$page->admin_js = true; //loads main.js 
		//if(empty($config['colorbox_style'])) $config['colorbox_style'] = 'example5';
		//$page->css_user[] = '/include/thirdparty/colorbox139/'.$config['colorbox_style'].'/colorbox.css';
if (file_exists($dataDir.'/include/thirdparty/colorbox')){
		$page->css_user[] = '/include/thirdparty/colorbox/example5/colorbox.css';
		$page->head_js[] = '/include/thirdparty/colorbox/colorbox/jquery.colorbox.js';
	}else{ message("no".$dataDir);	
		$page->css_user[] = '/include/thirdparty/colorbox139/example5/colorbox.css';
		$page->head_js[] = '/include/thirdparty/colorbox139/colorbox/jquery.colorbox.js';
		

	}	
	
		$page->css_user[] = '/include/thirdparty/jquery_ui/jquery-ui.min.css';
		$page->head_js[] = '/include/thirdparty/jquery_ui/core.js';	
		$page->head_js[] = '/include/thirdparty/jquery_ui/jquery-ui.min.js';
		$page->head_js[] = '/include/thirdparty/jquery_ui/widget.js';
		$page->head_js[] = '/include/thirdparty/jquery_ui/mouse.js';
		$page->head_js[] = '/include/thirdparty/jquery_ui/draggable.js';
		$page->head_js[] = '/include/thirdparty/jquery_ui/droppable.js'; 
		
		$page->head_js[] = $addonRelativeCode.'/shapeshift/jquery.shapeshift.min.js';
		$page->head_js[] = $addonRelativeCode.'/shapeshift/imagesloaded.pkgd.min.js';

		$page->head_js[] = $addonRelativeCode.'/zoom/jquery.zoom.min.js';
		$page->head_js[] = $addonRelativeCode.'/gallery.js';
		$page->css_user[] = $addonRelativeCode.'/gallery.css';

		$trns = array(
		'dialogTitle' => gpOutput::SelectText('Links to copied clipboard'),
		'Helptext' => gpOutput::SelectText('cntrl+c if you want to paste it into social media or emails'),
		'alreadyclipboard' => gpOutput::SelectText('This link has already been copied to the clipboard')
		);

		$page->head_script .= "\nvar CustomThumbnailGallery_trns = JSON.parse('".json_encode($trns,JSON_UNESCAPED_UNICODE)."');";

		$done = true;
	}


	/**
	 *
	 *
	 */
	static function InlineEdit_Scripts($scripts,$type){
		global $addonRelativeCode;
		
		if( $type !== self::ContentKey() ){
			return $scripts;
		}

		$scripts[] = '/include/js/inline_edit/inline_editing.js';
		$scripts[] = '/include/js/inline_edit/image_common.js';
		$scripts[] = $addonRelativeCode.'/gallery_edit.js';
		$scripts[] = '/include/js/jquery.auto_upload.js';

		return $scripts;
	}

	
	static function Admin(){
		global $page, $dataDir, $addonRelativeCode, $addonPathData, $addonFolderName, $addonPathCode;

		$galdata = self::GetData(); //$galdata['ThumbGalData']['ThumbDir'] $galdata['ThumbDirAndDimens']   ['width']['width']
		
		$cmd = common::GetCommand();
		switch($cmd){			
			case 'CustomThumbnailInline':
				self::CustomThumbnailInline($galdata);
				exit;
			case 'CustomThumbnailInlineSelect':
				self::CustomThumbnailInlineSelect($galdata);
				exit;
		}
	
		
		$page->css_user[] = '/include/thirdparty/codemirror/lib/codemirror.css';		
		$page->head_js[] = '/include/thirdparty/codemirror/lib/codemirror.js';
		//$page->head_js[] = $addonRelativeCode.'/codemirror/placeholder.js';		
		$page->head_js[] = $addonRelativeCode.'/codemirror/mode/javascript.js';
		$page->head_js[] = $addonRelativeCode.'/codemirror/mode/less.js';		
		echo '<h2>'.CustomThumbnailGallery::LangMessages("Custom Thumbnail Gallery").'</h2>';
//print_r($galdata);
//print key($galdata['ThumbDirAndDimens']);

		// if datadir not exists
		if (!file_exists($addonPathData.'/'.self::DataIndexFile))
			self::CopyDataFolder($addonPathCode."/defaults", $addonPathData);
		//return;
	}	

//::::::::::::::::::::::::::::::::::::
//___________________________________

	static function CustomThumbnailInlineSelect($galdata){
		//print_r($_GET);
		echo '<div class="half_width">'.self::LangMessages('Gallery template');

		self::ListSelect($_GET['selname'], $galdata['ThumbGalData'], $_GET['selected']);
		echo '</div>';
		if(!empty($_GET['thumbsel'])){
			echo '<div class="half_width">'.self::LangMessages('Thumb dir');
			if(!isset($_GET['thumbsel']['selected'])) $_GET['thumbsel']['selected'] = "";
			self::ListSelect($_GET['thumbsel']['selname'], $galdata['ThumbDirAndDimens'], $_GET['thumbsel']['selected'], 'ThumbDir');
			echo '</div>';
		}
		echo '<a class="ckeditor_control full_width" id="onlypreview">Preview</a>';
		
	}
	
	
	static function CustomThumbnailInline($galdata){
	
		$thumbHTML = $_GET['thumbHTML']; //from jquery

		$thumbdir = self::GetThumbDirname($_GET['templatekey'], $_GET['thumbdirname'], $galdata);//$thumbdir["thumbdir"] $thumbdir['height'] $thumbdir['width'] $out["nodif"]
	
		$dom = new DOMDocument();
		$dom->loadHTML($thumbHTML);
		$thumb = $dom->getElementsByTagName('img')->item(0)->getAttribute('src');
		$a_href = $dom->getElementsByTagName('a')->item(0)->getAttribute('href');

		$thumb_path = str_replace('/data/_uploaded/image/thumbnails/', '/data/_uploaded/image/'.$thumbdir["thumbdir"].'/', $thumb);
		$li_template = $galdata['ThumbGalData'][$_GET['templatekey']]['li_template'];
		$otherattr = ' data-arg="gallery_gallery" data-cmd="gallery" ';
		$classes = ' gallery_gallery ';
		$out = self::ReplaceInLiTemplate($li_template, array('{$a_href}'=>$a_href, '{$thumb_path}'=>$thumb_path, '{$classes}'=>$classes, '{$otherattr}'=>$otherattr));

	//	if (file_exists($_SERVER['DOCUMENT_ROOT'].$customthumb)){
			//print "OLEMAS";
	//		print '<li>'.$a_href. '</li>';
	//		exit;		
	//	}
				
		self::CreateThumbnail(rawurldecode($a_href), $thumbdir);

		print '<li>'.$out. '</li>';
		
	}

	
	
	static function CreateThumbnail($original, $thumbdir){
		global $config, $dataDir;

		if(empty($thumbdir["thumbdir"]))
			return false;
		
		$original = str_replace("//", "/", $_SERVER['DOCUMENT_ROOT'].$original);

		if (!file_exists($original))
			return false;		

		$prefix = $dataDir.'/data/_uploaded/';
		$thumb_prefix = $prefix.'image/'.$thumbdir["thumbdir"];
		
		if( strpos($original, $thumb_prefix) !== false ){
			return false;
		}
//print "<br>".$original."<br>".$prefix."<br>".$thumb_prefix;	
		if( strpos($original, $prefix) !== 0 ){
			return false;
		}
	
		$len = strlen($prefix);
		$thumb_path = substr($original, $len);
		$thumb_path = $thumb_prefix."/".$thumb_path;

		$thumb_dir = common::DirName($thumb_path);
		$thumb_path = $thumb_dir.'/'.basename($thumb_path).'.jpg';
		gpFiles::CheckDir($thumb_dir);
			
		self::CreateThumbImage($original, $thumb_path, $thumbdir['width'], $thumbdir['height'], $thumbdir['modus']);
	}


	static function CreateThumbImage($source_path, $dest_path, $new_w, $new_h, $square=false, $img_type=false){
		
		includeFile('tool/Images.php');
		
		// square image if $square not false
		if($square && !empty($new_w)){
			thumbnail::createSquare($source_path, $dest_path, $new_w, $type_file=false);
			return;
		}
		
		$src_img = thumbnail::getSrcImg($source_path,$img_type);
		
		if( !$src_img ){
			return false;
		}
		
//thumbnail::createSquare($source_path,$dest_path,$size=50,$type_file=false);
//max size FORM field - width checked
#$new_w=200; //$new_h="" or untset (max size width, all image width is same and height is propotionally smaller)
//max size FORM field - height checked
#$new_h=200; //$new_w="" or untset (max size height, all image height is same and with is propotionally smaller)
//max size FORM field - height and width both checked
#$new_h=200; $new_w=200; //if height or width is bigger then height or width is propotionally smaller (height is not allow bigger and width also)

		//Size
		$old_w = imagesx($src_img);
		$old_h = imagesy($src_img);

		if( empty($new_w))
			$new_w=$old_w;
	
		if( empty($new_h))
			$new_h=$old_h;
	
		$dst_x = 0;
		$dst_y = 0;


		$width_ratio = $new_w / $old_w;
		$height_ratio = $new_h / $old_h;

			if( $width_ratio < $height_ratio){
				$temp_h = round($width_ratio * $old_h);
				$temp_w = $new_w;

			}else{
				$temp_w = round($height_ratio * $old_w);
				$temp_h = $new_h;
			}		
		
		#::: Myhack - make thumbnail creation propotionally
		$new_w = "";
		$new_h = ""; 
		#:::
		return thumbnail::createImg($src_img, $dest_path, $dst_x, $dst_y, 0, 0, $temp_w, $temp_h, $old_w, $old_h, $new_w, $new_h);
	}
	
	static function ThumbnailPath($img, $thumbdirname){

		//already thumbnail path
		if( strpos($img,'/data/_uploaded/image/'.$thumbdirname) !== false ){
			return $img;
		}

		$dir_part = '/data/_uploaded/';
		$pos = strpos($img,$dir_part);
		if( $pos === false ){
			return $img;
		}

		return substr_replace($img,'/data/_uploaded/image/'.$thumbdirname.'/',$pos, strlen($dir_part) ).'.jpg';
	}
}



