<?php
/* UTF-8! 
######################################################################
Rif Custom ThumbnailGallery plugin fo gpEasy
Author: Rif T. Laasi
Date: 2016-02-20
Version 2.0 beta
######################################################################
*/
defined('is_running') or die('Not an entry point...');

class ThumbnailGalleryFunctions{


	const DataIndexFile = 'ThumbnailGalleryIndex.php';
	const DefNamePart= 'ThumbnailGallery';
	const ThumbDir= 'thumbnails';

	static function LangMessages($key){
		global $langmessage, $addon_current_id;

		if(!isset($langmessage[$addon_current_id][$key]))
			return $key;
		
		return $langmessage[$addon_current_id][$key];
	}
	
//$galdata = self::GetData(); //$galdata['ThumbGalData']['ThumbDir'] $galdata['ThumbDirAndDimens']   ['width']['width']
	static function GetData(){
		global $addonPathData, $config;
		$ThumbGalData = array();
		$ThumbDirAndDimens = array();
		$ThumbGalData = gpFiles::Get( $addonPathData.'/'.self::DataIndexFile, self::DefNamePart);
		$ThumbDirAndDimens = gpFiles::Get( $addonPathData.'/'.self::DataIndexFile, self::ThumbDir);
		
		if (empty($ThumbDirAndDimens) or !isset($ThumbDirAndDimens['thumbnails_default']))
			$ThumbDirAndDimens['thumbnails_default'] = array('width' => $config['maxthumbsize'], 'height' => '');
		foreach ($ThumbDirAndDimens as $key => $val){
			if (empty($val['height']) && empty($val['width'])){
				$ThumbDirAndDimens[$key]['height'] = "";
				$ThumbDirAndDimens[$key]['width'] = $config['maxthumbsize'];
			}
			if (!isset($val['height']))
				$ThumbDirAndDimens[$key]['height'] = $config['maxthumbsize'];
			if (!isset($val['width']))
				$ThumbDirAndDimens[$key]['width'] = $config['maxthumbsize'];
			if (empty($val['modus']))
				$ThumbDirAndDimens[$key]['modus'] = 0;
			
			$ThumbDirAndDimens[$key]['ThumbDir'] = $key;
		}
	
		if (empty($ThumbGalData))
			$ThumbGalData[0] = array('templatename' => 'Default', 'ThumbDir' => 'thumbnails_default');
		foreach ($ThumbGalData as $key => $val){
			if (empty($val['ThumbDir']))
				$ThumbGalData[$key]['ThumbDir'] = 'thumbnails_default';
			if (empty($val['classes']['container']))
				$ThumbGalData[$key]['classes']['container'] = 'gp_gallery';
			if (empty($val['li_template']))
				$ThumbGalData[$key]['li_template'] = '<a title="{$title_caption}" href="{$a_href}" class="{$classes}" {$otherattr}>'
				.'<img src="{$thumb_path}" alt="" /></a>'
				.'<div class="caption">{$caption}</div><div class="addOtherHTML">{$addOtherHTML}</div>';
		}
			
		return array('ThumbGalData' => $ThumbGalData, 'ThumbDirAndDimens' => $ThumbDirAndDimens);

	}

	
//$thumbdir = GetThumbDirname($_GET['templatekey'], $_GET['thumbdirname'], $galdata);//$thumbdir["thumbdir"] $thumbdir['height'] $thumbdir['width'] $out["nodif"]	
	static function GetThumbDirname($templatekey, $thumbdirname, $galdata){
		
		$out["thumbdir"] = $galdata['ThumbDirAndDimens']['thumbnails_default']['ThumbDir'];
		$out['height'] = $galdata['ThumbDirAndDimens']['thumbnails_default']['height'];
		$out['width'] = $galdata['ThumbDirAndDimens']['thumbnails_default']['width'];
		$out['modus'] = $galdata['ThumbDirAndDimens']['thumbnails_default']['modus'];
		
		if (isset($templatekey) && array_key_exists($galdata['ThumbGalData'][$templatekey]['ThumbDir'], $galdata['ThumbDirAndDimens'])){			
			$thumbdir =	$galdata['ThumbGalData'][$templatekey]['ThumbDir'];
		}
		
		if (!empty($thumbdirname) && isset($galdata['ThumbDirAndDimens'][$thumbdirname])){
			if(isset($thumbdir) && $thumbdir == $galdata['ThumbGalData'][$templatekey]['ThumbDir'])
				$out["nodif"] = true;
			$thumbdir = $galdata['ThumbDirAndDimens'][$thumbdirname]['ThumbDir'];
		}
				
		if(isset($thumbdir)){
			$out["thumbdir"] = $galdata['ThumbDirAndDimens'][$thumbdir]['ThumbDir'];
			$out['height'] = $galdata['ThumbDirAndDimens'][$thumbdir]['height'];
			$out['width'] = $galdata['ThumbDirAndDimens'][$thumbdir]['width'];
			$out['modus'] = $galdata['ThumbDirAndDimens'][$thumbdir]['modus'];
		}
		
		return $out;
			
	}

	
	function detect_rifminicart($file="minicart.php", $check=false){
		global $addonPathData;
		
		return false;
		
		$path = file_get_contents($addonPathData.'/minicartplug');
		if (class_exists('rifminicart_Common') && $check) {
			$minicart_reflector = new ReflectionClass("rifminicart_Common");
			$class_file_dir = dirname($minicart_reflector->getFileName());			
			if ($path !== $class_file_dir){
				file_put_contents($addonPathData.'/minicartplug', $class_file_dir);
				$path = $class_file_dir;
			}
		}

		if (file_exists($path.'/'.$file)) {
			include_once ($path.'/Common.php');			
			include_once ($path.'/'.$file);
			return true;
		}else
			return false;
	}
	
	
	static function CopyDataFolder($fromDir,$toDir){

		if( !gpFiles::CheckDir($toDir) ){
			return 'Copy failed: '.$fromDir.' to '.$toDir;
		}

		$files = scandir($fromDir);
		if( $files === false ){
			return 'scandir failed: '.$fromDir;
		}

		foreach($files as $file){
			if( strpos($file,'.') === 0)
				continue;

			$fullFrom = $fromDir.'/'.$file;
			$fullTo = $toDir.'/'.$file;
			//directories
			if( is_dir($fullFrom) ){
				$result = self::CopyDataFolder($fullFrom,$fullTo);
				if( $result !== true )
					return $result;
				continue;
			}
			//files
			//If the destination file already exists, it will be overwritten.
			if( !copy($fullFrom,$fullTo) ){
				return 'Copy failed: '.$fullFrom.' to '.$fullTo.' (2)';
			}
		}

		return true;
	}
	
	static function ListSelect($selname, $ThumbGalData, $selected, $varname = "templatename"){
		
		$attr = '';
		echo '<select name="'.$selname.'" class="gpselect" id="getmenutemplateData">';
		
		foreach ($ThumbGalData as $key => $val){
			
			if(!empty($ThumbGalData[$key]['ThumbDir']))
				$attr = ' data-template="'.$ThumbGalData[$key]['ThumbDir'].'" ';
				
			$sel = '';
			if( $selected == $key){
				$sel = ' selected="selected"';
			}
			echo '<option value="'.$key.'"'.$attr.''.$sel.'>'.htmlspecialchars($val[$varname]).'</option>';
		}
		
		echo '</select>';
	}


	static function base64url_encode($data) { 
		return rtrim(strtr(base64_encode($data), '+/', '-_'), '='); 
	} 

	static function base64url_decode($data) { 
		return base64_decode(str_pad(strtr($data, '-_', '+/'), strlen($data) % 4, '=', STR_PAD_RIGHT)); 
	}	
}